#!/bin/bash
#
# inventory_get_disks.sh
#
# wird von send_inventory aufgerufen
#
# Inventorydaten getrennt nach SAN und DAS Disks generieren in GByte:
#
# PARTITION;<Mountpoint|Swap>;<total>;<used>;<free>;[<mountopts>];<DAS|SAN|VG|MD>;<SerialNumber|name>;<partsize>     pro Partition
# VGRP;<vgname>;<total GByte>;<DAS|SAN|MD>;<SerialNumber|name>[;<DAS|SAN|MD>;<SerialNumber|name>...]
# MDDEV;<mdname>;<netto-disks>;<DAS|SAN>;<SerialNumber>[;<DAS|SAN>;<SerialNumber>...]
# DASDISK;<SerialNumber>;<total>;<alloc>;<free from alloc>;<SCSI>;<sdx>
# SANDISK;<SerialNumber>;<total>;<alloc>;<free from alloc>;<SCSI>;<sdx>
# DAS;<total GByte>;<alloc>;<used>;<free from alloc>;<free from alloc - adj>
# SAN;<total GByte>;<alloc>;<used>;<free from alloc>;<free from alloc - adj>
############################################################################
#
cd `dirname $0`
#
LANG=C
LC_ALL=C
export LANG LC_ALL
#
KERNEL=`uname -r`
( if [[ $KERNEL == 3* && -x /usr/sbin/hwinfo ]]; then
/usr/sbin/hwinfo --disk | awk '
BEGIN { while( (getline <"/proc/partitions") > 0 )
        { if( $1 ~ "[0-9]" && $NF !~ "^fd[0-9]" )
            ps[$NF] = $3/1024/1024
        }
        close("/proc/partitions")
        t = "DAS"
        FS = " *:  *"
      }
/^[0-9][0-9]*/ { if( dd != "" )
                   d = dd
                 if( d != "" )
                 { if( !size )
                     size = ps[d]
                   if( !sn )
                     sn = si ? si : sp
                   if( t != "USB" && ps[d] )
                     print "D;" d ";" t ";" sn ";" size ";" (scsi != "" ? scsi : bscsi)
                 }
                 bscsi = scsi = sn = si = dd = d = size = ""
                 t = "DAS"
               }
/Model: "IBM DASD"/  { t = "DASD" }
$1 ~ "Device File$"  { split($2, a, " ")
                       d = a[1]
                       gsub(".*/","",d)
                     }
$1 ~ "Serial ID$"    { gsub("\"", "", $2)
                       si = $2
                     }
$1 ~ "SysFS BusID$"  { if( split($2, b, ":") == 4 )
                         bscsi = b[1]":"b[3]
                     }
$1 ~ "Device Files$" { if( $2 ~ "-fc-" || $2 ~ "-zfcp-" )
                         t = "SAN"
                       n = split($2, a, ", *")
                       for( i = 1; i <= n; i++ )
                       { if( a[i] ~ "by-id" && dd == "" )
                         { cmd = "./get_by-id.sh " a[i]
                           if( (cmd | getline gl) > 0 )
                           { split(gl, b, " ")
                             size = b[2]
                             dd = b[1]
                           }
                           close(cmd)
                         }
                         if( a[i] ~ "by-id/scsi-3" && sn == "" )
                         { sn = a[i]
                           gsub(".*scsi-3", "", sn)
                         }
                         if( a[i] ~ "by-id/wwn-0x" && sn == "" )
                         { sn = a[i]
                           gsub(".*wwn-0x", "", sn)
                         }
                         if( a[i] ~ "by-path/" )
                         { sp = a[i]
                           gsub(".*by-path/", "", sp)
                           if( a[i] ~ "-scsi-" )
                           { gsub(".*-scsi-", "", a[i])
                             if( split(a[i], b, ":") == 4 )
                               scsi = b[1]":"b[3]
                           }
                         }
                       }
                     }
$1 ~ "Attached to$" { if( $2 ~ "Fibre Channel" )
                        t = "SAN"
                      else if( $2 ~ "USB" )
                        t = "USB"
                    }
END { if( dd != "" )
        d = dd
      if( !size )
        size = ps[d]
      if( !sn )
        sn = si ? si : sp
      if( t != "USB" && ps[d] )
        print "D;" d ";" t ";" sn ";" size ";" (scsi != "" ? scsi : bscsi)
    }'
  else
    awk '$NF ~ "^.d[a-z]+$|^rd/c[0-9]+d[0-9]+$|^dm-"{print $3/1024/1024, $NF, $1 "-" $2}' /proc/partitions | while read SIZE D MM; do
      if grep -Eq 'udev|devtmpfs' /proc/mounts; then
        SN=`ls -lU /dev/disk/by-id | egrep -v '^dm|lvm' | awk '$NF == "../../'$D'" {gsub("^wwn-0x|^scsi-[0-9]|^scsi-SATA_|^ata-","",$(NF-2));p=$(NF-2)};END{print p}'`
        DP=`ls -l /dev/disk/by-path | awk '$NF == "../../'$D'" {if(!p++){gsub("-zfcp-","-fc-",$(NF-2));print $(NF-2)}}'`
        if [[ -L /sys/class/block/$D ]]; then
          SCSI=$(readlink -f /sys/class/block/$D | awk -F '/' '{split($(NF-2),a,":");print a[1] ":" a[3]}')
        else
          SCSI=`ls -l /dev/disk/by-path | awk '$NF == "../../'$D'" {if(!p++){gsub(".*-scsi-|.*-fc-|.*-zfcp-","",$(NF-2));if(split($(NF-2),b,":")==4)print b[2]":"b[3]}}'`
        fi
      else
        unset SN DP SCSI
      fi
      if [[ -z "$SN" && ("${DP#*-fc-}" != "${DP#*-scsi-}" || -z "$DP") ]]; then
        if [[ -x /sbin/sdparm ]]; then
          SN=`/sbin/sdparm --inquiry /dev/$D 2>/dev/null | awk '/id_type: NAA/{getline;gsub("0x","");gsub("[][]","");print $1}'`
          if [[ -z "$SN" ]]; then
            SN="${DP:-$D}"
          fi
        elif [[ -x /usr/bin/scsiinfo ]]; then
          SN=`/usr/bin/scsiinfo -s /dev/$D | awk -F "'" '/Serial/{print $2}'`
          if [[ -z "$SN" ]]; then
            SN="${DP:-$D}"
          fi
        else
          SN="${DP:-$D}"
        fi
      fi
      if [[ "${DP#*-fc-}" != "$DP" ]]; then
        T="SAN"
      else
        T="DAS"
      fi
      if [[ ${D#?d} != $D ]]; then
        echo "D;$D;$T;$SN;$SIZE;$SCSI"
      fi
    done
  fi | sort -u
  #
  ls -l /dev/mapper | fgrep ',' | sed 's/,/ /' | awk '{print "M;" $5 "-" $6 ";" $NF}'
  #
  if [[ -f /proc/mdstat ]]; then
    awk '$1 ~ "^md" && $2 == ":" { if( $4 == "raid0" && NF > 5 )
                     { f = NF-4
                       g = NF-4
                     }
                     else if( ($4 == "raid5" || $4 == "raid4") && NF > 5 )
                     { f = NF-5
                       g = NF-4
                     }
                     else
                     { f = 1
                       g = 2
                     }
                     printf("R;%s;%f;%f", $1, f, g)
                     for( i=5; i<=NF; i++ )
                     { gsub("[0-9]*[[].*", "", $i)
                       printf(";%s", $i)
                     }
                     printf("\n")
                   }' /proc/mdstat
  fi
  #
  if [[ -x /sbin/pvs ]]; then
    /sbin/pvs --noheadings --units g --nosuffix 2>/dev/null | while read sd vg d a g f; do
            if [[ $sd != ${sd#/dev/md} ]]; then
              echo "M;$vg;${sd#/dev/};$g;$f"
            elif [[ "$sd" != "${sd#/dev/disk/by-id/scsi-}" ]]; then
              echo "V;$vg;${sd#/dev/disk/by-id/scsi-?};$g;$f"
            else
              if [[ "$sd" != "${sd#/dev/disk/by-id/}" ]]; then
                P=`ls -l $sd | awk '{print $NF}'`
                SN=`ls -l /dev/disk/by-id | awk '$(NF-2) ~ "scsi-" && $NF == "'$P'" {gsub("-part.*","",$(NF-2));gsub("^scsi-[0-9]|^scsi-SATA_","",$(NF-2));print $(NF-2)}'`
                DP=`ls -l /dev/disk/by-path | awk '$NF == "'$P'" {gsub("-part.*","",$(NF-2));print $(NF-2)}'`
                D=${P#../../}
              elif [[ "${sd#/dev/dasd}" != "${sd#/dev/sd}" ]]; then
                D="${sd#/dev/}"
                D="${D%%[0-9]*}"
                SN=`ls -lU /dev/disk/by-id | egrep -v '^dm|lvm' | awk '$NF == "../../'$D'" {gsub("^wwn-0x|^scsi-[0-9]|^scsi-SATA_|^ata-","",$(NF-2));p=$(NF-2)};END{print p}'`
                DP=`ls -l /dev/disk/by-path | awk '$NF == "../../'$D'" {if(!p++){gsub("-zfcp-","-fc-",$(NF-2));print $(NF-2)}}'`
              elif [[ "$sd" != "${sd#/dev/rd/}" ]]; then
                SN=""
                DP=""
                D="${sd#/dev/}"
                D="${D%p*}"
              elif [[ "$sd" != "${sd#/dev/mapper/}" ]]; then
                TT=`stat -L -c %t:%T "$sd"`
                SN=`stat -L -c "%t:%T %n" /dev/disk/by-id/dm-uuid-mpath-* | awk '$1 == "'$TT'" {gsub(".*/dm-uuid-mpath-[0-9]","",$2);print $2}'`
                DP=""
                D="${sd#/dev/}"
              else
                SN=""
                DP=""
                D="${sd#/dev/}"
              fi
              if [[ -z "$SN" ]]; then
                if [[ -x /sbin/sdparm ]]; then
                  SN=`/sbin/sdparm --inquiry $sd 2>/dev/null | awk '/id_type: NAA/{getline;gsub("0x","");gsub("[][]","");print $1}'`
                  if [[ -z "$SN" ]]; then
                     SN="${DP:-$D}"
                  fi
                elif [[ -x /usr/bin/scsiinfo ]]; then
                  SN=`/usr/bin/scsiinfo -s $sd | awk -F "'" '/Serial/{print $2}'`
                  if [[ -z "$SN" ]]; then
                    SN="${DP:-$D}"
                  fi
                else
                  SN="${DP:-$D}"
                fi
              fi
              echo "V;$vg;$SN;$g;$f"
            fi
          done
  fi
  #
  { for f in /dev/mapper/* ; do echo "L $f $(readlink -f $f)"; done
    cat /proc/swaps
  } | awk '$1 == "L" { l[$3] = $2}; $2 == "partition" {print "U;" (l[$1] ? l[$1] : $1) ";" $4/1024/1024 ";" ($3-$4)/1024/1024 ";" $3/1024/1024 ";swap"}'
  #
  df -mP `awk '
  $1 ~ "^/dev" && $1 !~ "/dev/loop" && $2 !~ "media" {print $1}' /proc/mounts | sort -u` | awk '
  BEGIN { gopt = "cat /proc/mounts"
          while( (gopt | getline) > 0 )
            mopt[$2] = $4
          close(gopt)
        }
  $1 ~ "^/dev" {
    if( $2 == 0 )
      f = 0
    else
    { f = 4 - log($2/1024)/2.3
      if( f < 0 )
        f = 0
    }
    bd = "blockdev --getsize64 " $1
    if( (bd | getline ts) <= 0 )
      ts = 0
    close(bd)
    if( ts > 0 )
      printf("U;%s;%f;%f;%f;%s;%s;%f\n", $1, $3/1024, $4/1024, $2/1024, $NF, mopt[$NF], ts / 1073741824)
    else
      printf("U;%s;%f;%f;%f;%s;%s;\n", $1, $3/1024, $4/1024, $2/1024, $NF, mopt[$NF])
  }'
) | awk -F ';' '
BEGIN { minscsi = 16 }
#
# Disc Device
# D;<dev>;SAN|DAS;<sernum>;<size>;<scsi-id>
$1 == "D" { s[$2] = $4
            if( ! t[$4] )
              cs[$3] += $5
            t[$4] = $3
            c[$2] = $5
            if( 2 == split($6, a, ":") )
            { scsi1[$2] = a[1]
              scsi2[$2] = a[2]
              if( a[1] < minscsi )
                minscsi = a[1]
            }
          }
#
# MD-Raid
# R;<dev>;<netto-n-disk>;<brutto-n-disk>;<disks>[;...]
$1 == "R" { mf[$2] = 1/$3
            mn[$2] = 1/$4
            printf("MDDEV;%s;%d", $2, $3)
            for(i=5;i<=NF;i++)
            { mi[$2":"i-4]=$i
              printf(";%s;%s", t[s[$i]], s[$i])
            }
            printf("\n")
          }
#
# LVM-Group
# V;<vgname>;<serial>;<size>;<free>
$1 == "V" { nv[$2]++
            vg[$2] = 1
            v[$2":"nv[$2]] = $3
            cv[$2":"nv[$2]] = $4
            sv[$2] += $4
          }

$1 == "M" { nv[$2]++
            v[$2":"nv[$2]] = $3
            cv[$2":"nv[$2]] = $4
            sv[$2] += $4
          }
##############################################
# t[]:  t[<serial>] = SAN|DAS
# cs[]: cs[SAN|DAS] = SUM(<size>)
# s[]:  s[<disk>]   = <serial>    <disk>: hda, sda, ..
# c[]:  c[<disk>]   = <size>
# minscsi: offset der scsi1[]
# scsi1[]: scsi1[<disk>] = <SCSI-ID> target
# scsi2[]: scsi2[<disk>] = <SCSI-ID> lun
# mf[]: mf[<md?>]   = <faktor>    x Byte: x*<faktor> pro Disk
# mn[]: mn[<md?>]   = <faktor>    x Byte: x*<faktor> pro Disk ohne Raid
# mi[]: mi[<md?>:<nr>]     = <disk>
# nv[]: nv[<vg>|<md>]      = <num pvs>
# vg[]: vg[<vg>]           = 1 bei VGs
# v[]:  v[<vg>|<md>:<nr>]  = <serial>
# cv[]: cv[<vg>|<md>:<nr>] = <size> PV
# sv[]: sv[<vg>|<md>]      = <size> VG
# da[] Disk allocatet
# df[] Disk free
# ft[] SAN/DAS/DASD total
# fu[] SAN/DAS/DASD used
# ff[] SAN/DAS/DASD free
##############################################
$1 == "U" { if( $2 ~ "/dev/mapper/.*-" )
            { gsub("-","#",$2)
              gsub("##","-",$2)
              gsub("/dev/mapper/","",$2)
              gsub("#.*","",$2)
              disktype = "VG"
              diskname = $2
              if( nv[$2] == 1 )
              { dn = v[$2":1"]
                if( mf[dn] > 0 )
                { for(i=1;mi[dn":"i]!="";i++)
                  { da[s[mi[dn":"i]]] += $5*mf[dn]
                    df[s[mi[dn":"i]]] += $4*mf[dn]
                    if( $8 > 0 )
                      ft[t[s[mi[dn":"i]]]] += $8*mf[dn]
                    else
                      ft[t[s[mi[dn":"i]]]] += $5*mf[dn]
                    fu[t[s[mi[dn":"i]]]] += $3*mf[dn]
                    ff[t[s[mi[dn":"i]]]] += $4*mf[dn]
                    fn[t[s[mi[dn":"i]]]] += $4*mn[dn]
                  }
                }
                else
                { da[dn] += $5
                  df[dn] += $4
                  if( $8 > 0 )
                    ft[t[dn]] += $8
                  else
                    ft[t[dn]] += $5
                  fu[t[dn]] += $3
                  ff[t[dn]] += $4
                  fn[t[dn]] += $4
                }
              }
              else
              { for(vi=1;vi<=nv[$2];vi++)
                { dn = v[$2":"vi]
                  vf = cv[$2":"vi]/sv[$2]
                  if( mf[dn] > 0 )
                  { for(i=1;mi[dn":"i]!="";i++)
                    { da[s[mi[dn":"i]]] += $5*mf[dn]*vf
                      df[s[mi[dn":"i]]] += $4*mf[dn]*vf
                      if( $8 > 0 )
                        ft[t[s[mi[dn":"i]]]] += $8*mf[dn]*vf
                      else
                        ft[t[s[mi[dn":"i]]]] += $5*mf[dn]*vf
                      fu[t[s[mi[dn":"i]]]] += $3*mf[dn]*vf
                      ff[t[s[mi[dn":"i]]]] += $4*mf[dn]*vf
                      fn[t[s[mi[dn":"i]]]] += $4*mn[dn]*vf
                    }
                  }
                  else
                  { da[dn] += $5*vf
                    df[dn] += $4*vf
                    if( $8 > 0 )
                      ft[t[dn]] += $8*vf
                    else
                      ft[t[dn]] += $5*vf
                    fu[t[dn]] += $3*vf
                    ff[t[dn]] += $4*vf
                    fn[t[dn]] += $4*vf
                  }
                }
              }
            }
            else if( $2 ~ "/dev/mapper/" )
            {
            }
            else if( $2 ~ "/dev/md" )
            { gsub("/dev/","",$2)
              disktype = "MD"
              diskname = $2
              if( mf[$2] > 0 )
              { for(i=1;mi[$2":"i]!="";i++)
                { da[s[mi[$2":"i]]] += $5*mf[$2]
                  df[s[mi[$2":"i]]] += $4*mf[$2]
                  if( $8 > 0 )
                    ft[t[s[mi[$2":"i]]]] += $8*mf[$2]
                  else
                    ft[t[s[mi[$2":"i]]]] += $5*mf[$2]
                  fu[t[s[mi[$2":"i]]]] += $3*mf[$2]
                  ff[t[s[mi[$2":"i]]]] += $4*mf[$2]
                  fn[t[s[mi[$2":"i]]]] += $4*mn[$2]
                }
              }
            }
            else
            { gsub("/dev/","",$2)
              gsub("[0-9]*$","",$2)
              disktype = t[s[$2]]
              diskname = s[$2]
              da[s[$2]] += $5
              df[s[$2]] += $4
              if( $8 > 0 )
                ft[t[s[$2]]] += $8
              else
                ft[t[s[$2]]] += $5
              fu[t[s[$2]]] += $3
              ff[t[s[$2]]] += $4
              fn[t[s[$2]]] += $4
            }
            print "PARTITION;" $6 ";" $5 ";" $3 ";" $4 ";" $7 ";" disktype ";" diskname ";" $8
          }
END { for( sx in s )
        print t[s[sx]] "DISK;" s[sx] ";" c[sx] ";" 0.0+da[s[sx]] ";" 0.0+df[s[sx]] ";" scsi1[sx]-minscsi ":" scsi2[sx] ";" sx
      if( cs["DAS"] > 0 )
        print "DAS;" cs["DAS"] ";" 0.0+ft["DAS"] ";" 0.0+fu["DAS"] ";" 0.0+ff["DAS"] ";" 0.0+fn["DAS"]
      if( cs["DASD"] > 0 )
        print "DASD;" cs["DASD"] ";" 0.0+ft["DASD"] ";" 0.0+fu["DASD"] ";" 0.0+ff["DASD"] ";" 0.0+fn["DASD"]
      if( cs["SAN"] > 0 )
        print "SAN;" cs["SAN"] ";" 0.0+ft["SAN"] ";" 0.0+fu["SAN"] ";" 0.0+ff["SAN"] ";" 0.0+fn["SAN"]
      for( vgn in nv )
      { if( vg[vgn] )
        { printf("VGGRP;%s;%d", vgn, sv[vgn])
          for( i = 1; i <= nv[vgn]; i++ )
            printf(";%s;%s", t[v[vgn":"i]], v[vgn":"i])
          printf("\n")
        }
      }
    }'
